package org.artifactory.repo.system.suppliers;

import lombok.extern.slf4j.Slf4j;
import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;

import static org.artifactory.descriptor.repo.RepoType.PipeInfo;

/**
 * @author Tomer Slutsky
 */
@Slf4j
public class PipeinfoRepo extends SystemRepoBase {

    public PipeinfoRepo(CentralConfigService centralConfigService) {
        super(centralConfigService);
    }

    @Override
    public LocalRepoDescriptor buildDescriptor(String repoKey) {
        LocalRepoDescriptor localRepoDescriptor = new LocalRepoDescriptor();
        localRepoDescriptor.setType(PipeInfo);
        localRepoDescriptor.setKey(repoKey);
        return localRepoDescriptor;
    }
}
