package org.artifactory.servicetrust;

import org.artifactory.api.security.access.TokenSpec;
import org.jfrog.access.common.ServiceId;

/**
 * @author igoru
 */
public interface TokenSpecInboundService {

    /**
     * Create the specification for creating the paring token for this Artifactory instance
     */
    TokenSpec createPairingTokenSpec(ServiceId artifactoryServiceId, ServiceTrust trust, String subject, String scope,
            String baseUrl, String pairingUrl, String exchangeUrl);

    /**
     * Create the specification for creating the Master token for this Artifactory instance
     */
    TokenSpec createMasterTokenSpec(ServiceId artifactoryServiceId, String useCasePath, String pairingScope,
            String baseUrl, String exchangeUrl);

    /**
     * Create the specification for creating the scope token for this Artifactory instance
     */
    TokenSpec createExchangeTokenSpec(ServiceId artifactoryServiceId, String useCasePath);
}
